Index: /trunk/kernel/mm/vmm.h
===================================================================
--- /trunk/kernel/mm/vmm.h	(revision 656)
+++ /trunk/kernel/mm/vmm.h	(revision 657)
@@ -3,6 +3,5 @@
  *
  * Authors   Ghassan Almaless (2008,2009,2010,2011, 2012)
- *           Mohamed Lamine Karaoui (2015)
- *           Alain Greiner (2016,2017,2018,2019)
+ *           Alain Greiner (2016,2017,2018,2019,2020))
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -31,4 +30,5 @@
 #include <list.h>
 #include <queuelock.h>
+#include <remote_queuelock.h>
 #include <hal_gpt.h>
 #include <vseg.h>
@@ -208,8 +208,12 @@
 
 /*********************************************************************************************
- * This function modifies the size of the vseg identified by <process> and <base> arguments
- * in all clusters containing a VSL copy, as defined by <new_base> and <new_size> arguments.
- * This function is called by the sys_munmap() function, and can be called by a thread
- * running in any cluster, as it uses remote accesses.
+ * This function modifies the vseg identified by <process> and <base> arguments in all
+ * clusters containing a VSL copy, as defined by <new_base> and <new_size> arguments.
+ * The new vseg, defined by the <new_base> and <new_size> arguments must be included
+ * in the existing vseg. The target VSL size and base fields are modified in the VSL.
+ * This is done in all clusters containing a VMM copy to maintain VMM coherence. 
+ * It is called by the sys_munmap() and dev_fbf_resize_window() functions.
+ * It can be called by a thread running in any cluster, as it uses the vmm_resize_vseg() in
+ * the local cluster, and parallel RPC_VMM_RESIZE_VSEG for remote clusters.
  * It cannot fail, as only vseg registered  in VSL copies are updated.
  *********************************************************************************************
@@ -228,6 +232,7 @@
  * the VSL and remove all associated PTE entries from the GPT.
  * This is done in all clusters containing a VMM copy to maintain VMM coherence. 
- * This function can be called by a thread running in any cluster, as it uses the
- * vmm_remove_vseg() in the local cluster, and the RPC_VMM_REMOVE_VSEG for remote clusters.
+ * It is called by the sys_munmap() and dev_fbf_resize_window() functions.
+ * It can be called by a thread running in any cluster, as it uses the vmm_remove_vseg() in
+ * the local cluster, and parallel RPC_VMM_REMOVE_VSEG for remote clusters.
  * It cannot fail, as only vseg registered  in VSL copies are deleted.
  *********************************************************************************************
@@ -317,6 +322,5 @@
  * It must be called by a local thread, running in the cluster containing the modified VMM.
  * Use the RPC_VMM_REMOVE_VSEG if required.
- * It makes a kernel panic if the process is not registered in the local cluster,
- * or if the vseg is not registered in the process VSL.
+ * It makes a kernel panic if the process is not registered in the local cluster.
  * For all vseg types, the vseg is detached from local VSL, and all associated PTEs are
  * unmapped from local GPT. Other actions depend on the vseg type:
@@ -340,13 +344,9 @@
 /*********************************************************************************************
  * This function resize a local vseg identified by the <process> and <vseg> arguments.
- * It is called by the vmm_global_resize() function.
- * It must be called by a local thread, running in the cluster containing the modified VMM.
+ * Both the "size" and "base" fields are modified in the process VSL. When the new vseg
+ * contains less pages than the target vseg, the relevant pages are removed from the GPT. 
+ * It is called by the vmm_global_resize() and dev_fbf_resize_window() functions.
+ * It must be called by a local thread, running in the cluster containing the modified VSL.
  * Use the RPC_VMM_RESIZE_VSEG if required.
- * It makes a kernel panic if the process is not registered in the local cluster,
- * or if the vseg is not registered in the process VSL.
- * The new vseg, defined by the <new_base> and <new_size> arguments must be strictly
- * included in the target vseg. The target VSL size and base fields are modified in the VSL.
- * If the new vseg contains less pages than the target vseg, the relevant pages are
- * removed from the GPT. 
  * The VSL lock protecting the VSL must be taken by the caller.
  *********************************************************************************************
@@ -454,4 +454,3 @@
                          ppn_t  * ppn );
 
-
 #endif /* _VMM_H_ */
Index: /trunk/kernel/mm/vseg.c
===================================================================
--- /trunk/kernel/mm/vseg.c	(revision 656)
+++ /trunk/kernel/mm/vseg.c	(revision 657)
@@ -2,5 +2,5 @@
  * vseg.c - virtual segment (vseg) related operations
  *
- * Authors   Alain Greiner (2016,2017,2018,2019)
+ * Authors   Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/kernel/mm/vseg.h
===================================================================
--- /trunk/kernel/mm/vseg.h	(revision 656)
+++ /trunk/kernel/mm/vseg.h	(revision 657)
@@ -2,5 +2,5 @@
  * vseg.h - virtual segment (vseg) related operations
  *
- * Authors  Alain Greiner (2016,2017,2018,2019)
+ * Authors  Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/kernel/syscalls/shared_include/shared_fbf.h
===================================================================
--- /trunk/kernel/syscalls/shared_include/shared_fbf.h	(revision 656)
+++ /trunk/kernel/syscalls/shared_include/shared_fbf.h	(revision 657)
@@ -1,6 +1,6 @@
 /*
- * shared_framebuffer.h - Shared mnemonics used by the frame buffer related syscalls.
+ * shared_fbf.h - Shared mnemonics used by the frame buffer related syscalls.
  *
- * Author  Alain Greiner (2016,2017,2018,2019)
+ * Author  Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,14 +26,19 @@
 
 /******************************************************************************************* 
- * This enum defines the operation mnemonics for frame buffer access.
+ * This enum defines the user operation mnemonics for frame buffer access.
  ******************************************************************************************/
 
 typedef enum
 {
-    FBF_GET_CONFIG = 0,      
-    FBF_READ       = 1,
-    FBF_WRITE      = 2,
+    FBF_GET_CONFIG     = 0,      
+    FBF_DIRECT_READ    = 1,
+    FBF_DIRECT_WRITE   = 2,
+    FBF_CREATE_WINDOW  = 3,
+    FBF_DELETE_WINDOW  = 4,
+    FBF_REFRESH_WINDOW = 5,
+    FBF_MOVE_WINDOW    = 6,
+    FBF_RESIZE_WINDOW  = 7,
 }
-fbf_operation_type_t;
+fbf_usr_operation_type_t;
 
 #endif  // _SHARED_FRAMEBUFFER_H_
Index: /trunk/kernel/syscalls/shared_include/syscalls_numbers.h
===================================================================
--- /trunk/kernel/syscalls/shared_include/syscalls_numbers.h	(revision 656)
+++ /trunk/kernel/syscalls/shared_include/syscalls_numbers.h	(revision 657)
@@ -93,6 +93,7 @@
     SYS_GET_THREAD_INFO = 55,
     SYS_FBF             = 56,
+    SYS_SOCKET          = 57,
 
-    SYSCALLS_NR         = 57,
+    SYSCALLS_NR         = 58,
 
 } syscalls_t;
Index: /trunk/kernel/syscalls/sys_display.c
===================================================================
--- /trunk/kernel/syscalls/sys_display.c	(revision 656)
+++ /trunk/kernel/syscalls/sys_display.c	(revision 657)
@@ -2,5 +2,5 @@
  * sys_display.c - display the current state of a kernel structure on TXT0
  *
- * Author    Alain Greiner (2016,2017,2018, 2019)
+ * Author    Alain Greiner (2016,2017,2018,2019,2020)
  *  
  * Copyright (c) UPMC Sorbonne Universites
@@ -380,5 +380,5 @@
 
             // get extended pointer on target page
-            page_xp = mapper_remote_get_page( mapper_xp , page_id );
+            page_xp = mapper_get_page( mapper_xp , page_id );
 
             if( page_xp == XPTR_NULL )
@@ -446,11 +446,11 @@
         case DISPLAY_FAT:
         {
-            uint32_t  entries = (uint32_t)arg1;
-
-            if( entries > 4096 )
+            uint32_t  slots = (uint32_t)arg1;
+
+            if( slots > 1024 )
 	        {
 
 #if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s for FAT : nb_entries larger than 4096\n",
+printk("\n[ERROR] in %s for FAT : nb_slots larger than 1024\n",
 __FUNCTION__ );
 #endif
@@ -459,5 +459,5 @@
 	        }
 
-            if( entries == 0 )  // display fat context in cluster cxy
+            if( slots == 0 )  // display fat context in cluster cxy
             {
                 uint32_t  cxy = (uint32_t)arg0;
@@ -476,9 +476,9 @@
                 fatfs_display_ctx( cxy );
             }
-            else                  // display nb_entries in page 
+            else                  // display nb_slots in page 
             {                        
-                uint32_t page = (uint32_t)arg0;
-
-                fatfs_display_fat( page , 0 , entries );
+                uint32_t min  = (uint32_t)arg0;
+
+                fatfs_display_fat( min , slots );
             }
 
Index: /trunk/kernel/syscalls/sys_fbf.c
===================================================================
--- /trunk/kernel/syscalls/sys_fbf.c	(revision 656)
+++ /trunk/kernel/syscalls/sys_fbf.c	(revision 657)
@@ -2,5 +2,5 @@
  * sys_fbf.c - Acces the frame buffer peripheral.
  * 
- * Authors     Alain Greiner (2016,2017,2018,2019)
+ * Authors     Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -33,24 +33,28 @@
 #include <syscalls.h>
 
-//////////////////////////////////
-int sys_fbf( uint32_t   operation,
-             void     * arg0,           
-             void     * arg1,
-             void     * arg2 )
+////////////////////////
+int sys_fbf( reg_t arg0,
+             reg_t arg1,
+             reg_t arg2,
+             reg_t arg3 )
 {
 	vseg_t         * vseg;        // for vaddr check
     error_t          error;
 
+#if (DEBUG_SYS_FBF || CONFIG_INSTRUMENTATION_SYSCALLS)
+uint64_t     tm_start = hal_get_cycles();
+#endif
+
     thread_t       * this    = CURRENT_THREAD;
     process_t      * process = this->process;
 
-#if (DEBUG_SYS_FBF || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
+    // for some operations, the MSB of arg0 can contain the wid 
+    uint32_t operation = arg0 & 0xFFFF;
 
 #if DEBUG_SYS_FBF
 if( DEBUG_SYS_FBF < tm_start )
-printk("\n[%s] thread[%x,%x] enter for %s / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, dev_fbf_cmd_str( operation ), (uint32_t)tm_start );
+printk("\n[%s] thread[%x,%x] enter for %s / arg1 %x / arg2 %x / arg3 %x / cycle %d\n",
+__FUNCTION__, process->pid, this->trdid, dev_fbf_cmd_str( operation ),
+arg1, arg2, arg3, (uint32_t)tm_start );
 #endif
 
@@ -65,18 +69,5 @@
             uint32_t type;
 
-            // check arg0 (width) in user vspace
-	        error = vmm_get_vseg( process , (intptr_t)arg0 , &vseg );
-	        if( error )
-            {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : unmapped arg0 %x for %s / thread[%x,%x]\n",
-__FUNCTION__ , arg0, dev_fbf_cmd_str(operation), process->pid, this->trdid );
-#endif
-                this->errno = EINVAL;
-                return -1;
-            }
-
-            // check arg1 (height) in user vspace
+            // check "width" in user vspace
 	        error = vmm_get_vseg( process , (intptr_t)arg1 , &vseg );
 	        if( error )
@@ -88,9 +79,8 @@
 #endif
                 this->errno = EINVAL;
-                return -1;
-            }
-
-            // check arg2 (type) in user vspace
-	        error = vmm_get_vseg( process , (intptr_t)arg2 , &vseg );
+            }
+
+            // check "height" in user vspace
+	        error |= vmm_get_vseg( process , (intptr_t)arg2 , &vseg );
 	        if( error )
             {
@@ -101,5 +91,16 @@
 #endif
                 this->errno = EINVAL;
-                return -1;
+            }
+
+            // check "type" in user vspace
+	        error |= vmm_get_vseg( process , (intptr_t)arg3 , &vseg );
+	        if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : unmapped arg3 %x for %s / thread[%x,%x]\n",
+__FUNCTION__ , arg3, dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
             }
 
@@ -107,35 +108,149 @@
             dev_fbf_get_config( &width , &height , &type );
 
-            // transfer to user space
-            hal_copy_to_uspace( arg0 , XPTR( local_cxy , &width )  , sizeof(uint32_t) );
-            hal_copy_to_uspace( arg1 , XPTR( local_cxy , &height ) , sizeof(uint32_t) );
-            hal_copy_to_uspace( arg2 , XPTR( local_cxy , &type )   , sizeof(uint32_t) );
-        
-            break;
-        }
-        //////////////
-        case FBF_READ:
-        case FBF_WRITE:
-        {
-            // check arg0 (buffer) in user space
-	        error = vmm_get_vseg( process , (intptr_t)arg0 , &vseg );
-	        if( error )
-            {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : unmapped arg0 %x for %s / thread[%x,%x]\n",
-__FUNCTION__ , arg0, dev_fbf_cmd_str(operation), process->pid, this->trdid );
-#endif
-                this->errno = EINVAL;
-                return -1;
-            }
-
-            // get length and offset values
-
-            uint32_t length = (uint32_t)(intptr_t)arg1;
-            uint32_t offset = (uint32_t)(intptr_t)arg2;
+            // transfer to user space if no error
+            if( error == 0 )
+            {
+                hal_copy_to_uspace( (void*)arg1, XPTR(local_cxy , &width ), sizeof(uint32_t) );
+                hal_copy_to_uspace( (void*)arg2, XPTR(local_cxy , &height), sizeof(uint32_t) );
+                hal_copy_to_uspace( (void*)arg3, XPTR(local_cxy , &type  ), sizeof(uint32_t) );
+            }
+            break;
+        }
+        /////////////////////
+        case FBF_DIRECT_READ:
+        case FBF_DIRECT_WRITE:
+        {
+            void    * buffer   = (void *)arg1;
+            uint32_t  npixels  = arg2;
+            uint32_t  offset   = arg3;
+            bool_t    is_write = (operation == FBF_DIRECT_WRITE);
+            
+            // check buffer in user space
+	        error = vmm_get_vseg( process , (intptr_t)buffer , &vseg );
+	        if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : unmapped buffer %x for %s / thread[%x,%x]\n",
+__FUNCTION__ , buffer, dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
+            else
+            {
+                // call relevant kernel function
+                error |= dev_fbf_move_data( is_write, buffer, npixels, offset );           
+
+                if( error )
+                {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : cannot move data for %s / buffer %x / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), buffer, process->pid, this->trdid );
+#endif
+                    this->errno = EINVAL;
+                }
+            }
+            break;
+        }
+        ///////////////////////
+        case FBF_CREATE_WINDOW:
+        {
+            uint32_t   l_zero  = arg1 >> 16;
+            uint32_t   p_zero  = arg1 & 0xFFFF;
+            uint32_t   nlines  = arg2 >> 16;
+            uint32_t   npixels = arg2 & 0xFFFF;
+
+            // check buffer in user space
+	        error = vmm_get_vseg( process , (intptr_t)arg3 , &vseg );
+	        if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : unmapped user buffer %x for %s / thread[%x,%x]\n",
+__FUNCTION__ , (intptr_t)arg3, dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
+            else
+            {
+                // allocated buffer base address
+                intptr_t  user_buffer;
+     
+                // call relevant kernel function
+                error = dev_fbf_create_window( nlines,
+                                               npixels,
+                                               l_zero,
+                                               p_zero,
+                                               &user_buffer );
+                if( error == -1 )
+                {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : cannot create window for %s / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                    this->errno = EINVAL;
+                }
+
+                // copy vseg base address to user space buffer
+                hal_copy_to_uspace( (void *)arg3,
+                                    XPTR( local_cxy , &user_buffer ),
+                                    sizeof(intptr_t) );
+                hal_fence();
+            }
+            break;
+        }
+        ///////////////////////
+        case FBF_DELETE_WINDOW:
+        {
+            uint32_t  wid = arg1;
+
+            // call relevant kernel function
+            error = dev_fbf_delete_window( wid );
+                
+            if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : cannot delete window for %s / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
+            break;
+        }
+        ////////////////////////
+        case FBF_REFRESH_WINDOW:
+        {
+            uint32_t  wid        = arg1;
+            uint32_t  line_first = arg2;
+            uint32_t  line_last  = arg3;
+
+            // call relevant kernel function
+            error = dev_fbf_refresh_window( wid,
+                                            line_first,
+                                            line_last );
+                
+            if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : cannot refresh window for %s / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
+            break;
+        }
+        /////////////////////
+        case FBF_MOVE_WINDOW:
+        {
+            uint32_t  wid      = arg1; 
+            uint32_t  l_zero   = arg2;
+            uint32_t  p_zero   = arg3;
 
             // call relevant kernel function to move data
-            error = dev_fbf_move_data( operation , arg0 , length , offset ); 
+            error = dev_fbf_move_window( wid, l_zero, p_zero ); 
 
             if( error )
@@ -143,11 +258,30 @@
 
 #if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : cannot move data for %s / buffer %x / thread[%x,%x]\n",
-__FUNCTION__ , dev_fbf_cmd_str(operation), arg0, process->pid, this->trdid );
-#endif
-                this->errno = EINVAL;
-                return -1;
-            }
-          
+printk("\n[ERROR] in %s : cannot move window / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
+            break;
+        }
+        ///////////////////////
+        case FBF_RESIZE_WINDOW:
+        {
+            uint32_t  wid      = arg1; 
+            uint32_t  width    = arg2;
+            uint32_t  height   = arg3;
+
+            // call relevant kernel function to move data
+            error = dev_fbf_resize_window( wid , width , height ); 
+
+            if( error )
+            {
+
+#if DEBUG_SYSCALLS_ERROR
+printk("\n[ERROR] in %s : cannot move window / thread[%x,%x]\n",
+__FUNCTION__ , dev_fbf_cmd_str(operation), process->pid, this->trdid );
+#endif
+                this->errno = EINVAL;
+            }
             break;
         }
@@ -161,6 +295,7 @@
 #endif
             this->errno = EINVAL;
-            return -1;
-        }
+            error = -1;
+        }
+        break;
 	}  // end switch on operation
 
@@ -173,7 +308,6 @@
 #if DEBUG_SYS_FBF
 if( DEBUG_SYS_FBF < tm_end )
-printk("\n[%s] thread[%x,%x] exit for %s / cost = %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, dev_fbf_cmd_str( operation ),
-(uint32_t)(tm_end - tm_start), (uint32_t)tm_end );
+printk("\n[%s] thread[%x,%x] exit for %s / cycle %d\n",
+__FUNCTION__, process->pid, this->trdid, dev_fbf_cmd_str( operation ), (uint32_t)tm_end );
 #endif
 
@@ -183,5 +317,5 @@
 #endif
 
-    return 0;
+    return error;
 
 }  // end sys_fbf()
Index: /trunk/kernel/syscalls/sys_mmap.c
===================================================================
--- /trunk/kernel/syscalls/sys_mmap.c	(revision 656)
+++ /trunk/kernel/syscalls/sys_mmap.c	(revision 657)
@@ -2,5 +2,5 @@
  * sys_mmap.c - map files, memory or devices into process virtual address space
  * 
- * Authors       Alain Greiner (2016,2017,2018,2019)
+ * Authors       Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/kernel/syscalls/syscalls.h
===================================================================
--- /trunk/kernel/syscalls/syscalls.h	(revision 656)
+++ /trunk/kernel/syscalls/syscalls.h	(revision 657)
@@ -2,5 +2,5 @@
  * syscalls.h - Kernel side services for syscall handling.
  * 
- * Author     Alain Greiner (2016,2017,2018,2019)
+ * Author     Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -748,17 +748,36 @@
 
 /****************************************************************************************** 
- * [56] This function implements the non-standard "fbf_get_config", "fbf_read" and
- * "fbf_write" syscalls, used to access the frame buffer peripheral.
- ******************************************************************************************
- * @ operation  : [in] operation type (defined in shared_fbf.h)
- * @ arg0       : if config : pointer on width   / else : pointer on user buffer  
- * @ arg1       : if config : pointer on height  / else : number of bytes to move 
- * @ arg2       : if config : pointer on type    / else : offset in frame buffer
+ * [56] This generic function implements the non-standard FBF related syscalls.
+ * The operation types mnemonics are defined in the <shared_fbf> file.
+ * The supported operations are defined in the <almosmkh.h> & <almosmkh.c> files.
+ * This function ckecks the syscall arguments, and call the relevant kernel function.
+ ******************************************************************************************
+ * @ arg0       : operation type (mnemonics defined in shared_fbf.h)
+ * @ arg1       : depends on operation type
+ * @ arg2       : depends on operation type
+ * @ arg3       : depends on operation type
  * @ return 0 if success / return -1 if illegal argument.
  *****************************************************************************************/
-int sys_fbf( uint32_t   operation,
-             void     * arg0,
-             void     * arg1,
-             void     * arg2 );
+int sys_fbf( reg_t   arg0,
+             reg_t   arg1,
+             reg_t   arg2,
+             reg_t   arg3 );
+
+/****************************************************************************************** 
+ * [57] This generic function implements the socket related syscalls.
+ * The operation types mnemonics are defined in the <shared_socket> file.
+ * The supported operations are defined in the <socket.h> & <socket.c> files.
+ * This function ckecks the syscall arguments, and call the relevant kernel function.
+ ******************************************************************************************
+ * @ arg0       : operation type (mnemonics defined in shared_socket.h)
+ * @ arg1       : depends on operation type
+ * @ arg2       : depends on operation type
+ * @ arg3       : depends on operation type
+ * @ return 0 if success / return -1 if illegal argument.
+ *****************************************************************************************/
+int sys_socket( reg_t   arg0,
+                reg_t   arg1,
+                reg_t   arg2,
+                reg_t   arg3 );
 
 #endif  // _SYSCALLS_H_
